#!/bin/bash

# Older compiz versions start gtk-window-decorator only if GNOME_DESKTOP_SESSION_ID is set.
[ -n "$GNOME_DESKTOP_SESSION_ID" ] || export GNOME_DESKTOP_SESSION_ID="LXDE"

[ -x /usr/lib/gamin/gam_server ] && exec /usr/lib/gamin/gam_server --notimeout & sleep 2

# Set default cursor (artwiz)
xsetroot -cursor_name left_ptr &

export SAL_USE_VCLPLUGIN="gtk" GTK_MODULES="gail:atk-bridge" GNOME_ACCESSIBILITY=1 QT_ACCESSIBILITY=1
test -z "$SPEECHD_ADDRESS" && grep -q -E -i '^[[:space:]]*SocketPath[[:space:]]+"/var/run/speech-dispatcher/speechd.sock"' /etc/speech-dispatcher/speechd.conf >/dev/null 2>&1 && export SPEECHD_ADDRESS="unix_socket:/var/run/speech-dispatcher/speechd.sock"

# Starting gnome-settings-daemon will make iceweasel magically work with orca
if ! pidof -x gnome-settings-daemon >/dev/null 2>&1; then
 type -p gnome-settings-daemon >/dev/null 2>&1 && exec gnome-settings-daemon & sleep 2
fi

case "$1" in start*) ;; *) exec compiz --replace & sleep 5 ;; esac

{ sleep 5; startorca; } &

export LANG

# Orca, for some reason, switches keyboard layout to english.
# This is a painful attempt of a workaround.
(
 for ((i=0; i<30; i++)); do
  sleep 2
#  if xmodmap | grep -q 'mod1.*Alt_R'; then
   case "$LANG" in de*) setxkbmap -layout de -variant nodeadkeys;; esac
#   break
#  fi
 done
) &

# Execute program
"$@"

case "$STARTUP" in
 *soffice*|*firefox*|*chromium*) # Need to wait until forked programs disappear
  cmd="$(echo "$STARTUP" | awk '{print $NF}')"
  sleep 10
  while pidof -x "$cmd" "$cmd".bin >/dev/null 2>&1; do
   sleep 4
  done ;;
esac
